import type { IPadding } from './padding';
export declare abstract class ICrypter {
    private readonly padding;
    protected readonly abstract blockSize: number;
    constructor(padding: IPadding);
    protected abstract encryptBlocks(data: Uint8Array): Uint8Array;
    protected abstract decryptBlocks(data: Uint8Array): Uint8Array;
    encrypt(data: Uint8Array): Uint8Array;
    decrypt(data: Uint8Array): Uint8Array;
    encodeAndEncrypt(value: unknown): Uint8Array;
    decryptAndDecode<T = unknown>(data: Uint8Array): T;
}
