import * as functions from 'firebase-functions';
import { type IParameterContainer } from '../parameter';
import type { AuthData } from 'firebase-functions/lib/common/providers/https';
import { type ILogger } from '../logger';
import { Result } from '../utils';
export interface FirebaseFunction<Parameters, FlattenParameters, ReturnType> {
    parameters: Parameters;
    execute(): Promise<ReturnType>;
}
export type FirebaseFunctionConstructor<Parameters, FlattenParameters, ReturnType> = new (parameterContainer: IParameterContainer, auth: AuthData | null, logger: ILogger) => FirebaseFunction<Parameters, FlattenParameters, ReturnType>;
export declare namespace FirebaseFunction {
    type ValidReturnType = boolean | string | number | null | void | ValidReturnType[] | {
        [key: string]: ValidReturnType;
    };
    interface Flattable<Flatten extends FirebaseFunction.ValidReturnType> {
        flatten: Flatten;
    }
    namespace Flattable {
        function flatten(value: unknown): ValidReturnType;
    }
    function verifyMacTag(tag: string, parameters: unknown, key: Uint8Array): boolean;
    function execute<T>(_function: () => Promise<T>): Promise<Result<T, functions.https.HttpsError>>;
    function create<Parameters, FlattenParameters, ReturnType>(FirebaseFunction: FirebaseFunctionConstructor<Parameters, FlattenParameters, ReturnType>, macKey: Uint8Array, regions?: string[]): functions.HttpsFunction & functions.Runnable<unknown>;
}
