import * as functions from 'firebase-functions';
import { type IParameterContainer } from '../parameter';
import { type ILogger } from '../logger';
export interface FirebaseRequest<Parameters, FlattenParameters, ReturnType> {
    parameters: Parameters;
    execute(): Promise<ReturnType>;
}
export type FirebaseRequestConstructor<Parameters, FlattenParameters, ReturnType> = new (parameterContainer: IParameterContainer, logger: ILogger) => FirebaseRequest<Parameters, FlattenParameters, ReturnType>;
export declare namespace FirebaseRequest {
    function create<Parameters, FlattenParameters, ReturnType>(FirebaseRequest: FirebaseRequestConstructor<Parameters, FlattenParameters, ReturnType>, macKey: Uint8Array, regions?: string[]): functions.HttpsFunction;
}
