import type * as functions from 'firebase-functions';
import { type FirebaseFunctionConstructor } from './FirebaseFunction';
import { type FirebaseScheduleConstructor } from './FirebaseSchedule';
import { type FirebaseRequestConstructor } from './FirebaseRequest';
export declare class FirebaseFunctionConstructorWrapper<Parameters, FlattenParameters, ReturnType> {
    readonly Constructor: FirebaseFunctionConstructor<Parameters, FlattenParameters, ReturnType>;
    constructor(Constructor: FirebaseFunctionConstructor<Parameters, FlattenParameters, ReturnType>);
}
export declare class FirebaseScheduleConstructorWrapper {
    readonly Constructor: FirebaseScheduleConstructor;
    readonly schedule: string;
    readonly timezone: string;
    constructor(Constructor: FirebaseScheduleConstructor, schedule: string, timezone: string);
}
export declare class FirebaseRequestConstructorWrapper<Parameters, FlattenParameters, ReturnType> {
    readonly Constructor: FirebaseRequestConstructor<Parameters, FlattenParameters, ReturnType>;
    constructor(Constructor: FirebaseRequestConstructor<Parameters, FlattenParameters, ReturnType>);
}
export type FirebaseFunctions = FirebaseFunctionConstructorWrapper<unknown, unknown, unknown> | FirebaseScheduleConstructorWrapper | FirebaseRequestConstructorWrapper<unknown, unknown, unknown> | {
    [key: string]: FirebaseFunctions;
};
export declare namespace FirebaseFunctions {
    type IsFunction<Functions extends FirebaseFunctions> = Functions extends FirebaseFunctionConstructorWrapper<unknown, unknown, unknown> ? true : Functions extends FirebaseScheduleConstructorWrapper ? false : Functions extends FirebaseRequestConstructorWrapper<unknown, unknown, unknown> ? false : false;
    type IsSchedule<Functions extends FirebaseFunctions> = Functions extends FirebaseFunctionConstructorWrapper<unknown, unknown, unknown> ? false : Functions extends FirebaseScheduleConstructorWrapper ? true : Functions extends FirebaseRequestConstructorWrapper<unknown, unknown, unknown> ? false : false;
    type IsRequest<Functions extends FirebaseFunctions> = Functions extends FirebaseFunctionConstructorWrapper<unknown, unknown, unknown> ? false : Functions extends FirebaseScheduleConstructorWrapper ? false : Functions extends FirebaseRequestConstructorWrapper<unknown, unknown, unknown> ? true : false;
    type IsRecord<Functions extends FirebaseFunctions> = Functions extends FirebaseFunctionConstructorWrapper<unknown, unknown, unknown> ? false : Functions extends FirebaseScheduleConstructorWrapper ? false : Functions extends FirebaseRequestConstructorWrapper<unknown, unknown, unknown> ? false : true;
    type FunctionParameters<Functions extends FirebaseFunctions> = Functions extends FirebaseFunctionConstructorWrapper<infer Parameters, unknown, unknown> ? Parameters : Functions extends FirebaseScheduleConstructorWrapper ? never : Functions extends FirebaseRequestConstructorWrapper<unknown, unknown, unknown> ? never : never;
    type FunctionFlattenParameters<Functions extends FirebaseFunctions> = Functions extends FirebaseFunctionConstructorWrapper<unknown, infer FlattenParameters, unknown> ? FlattenParameters : Functions extends FirebaseScheduleConstructorWrapper ? never : Functions extends FirebaseRequestConstructorWrapper<unknown, unknown, unknown> ? never : never;
    type FunctionReturnType<Functions extends FirebaseFunctions> = Functions extends FirebaseFunctionConstructorWrapper<unknown, unknown, infer ReturnType> ? ReturnType : Functions extends FirebaseScheduleConstructorWrapper ? never : Functions extends FirebaseRequestConstructorWrapper<unknown, unknown, unknown> ? never : never;
    type RequestParameters<Functions extends FirebaseFunctions> = Functions extends FirebaseFunctionConstructorWrapper<unknown, unknown, unknown> ? never : Functions extends FirebaseScheduleConstructorWrapper ? never : Functions extends FirebaseRequestConstructorWrapper<infer Parameters, unknown, unknown> ? Parameters : never;
    type RequestFlattenParameters<Functions extends FirebaseFunctions> = Functions extends FirebaseFunctionConstructorWrapper<unknown, unknown, unknown> ? never : Functions extends FirebaseScheduleConstructorWrapper ? never : Functions extends FirebaseRequestConstructorWrapper<unknown, infer FlattenParameters, unknown> ? FlattenParameters : never;
    type RequestReturnType<Functions extends FirebaseFunctions> = Functions extends FirebaseFunctionConstructorWrapper<unknown, unknown, unknown> ? never : Functions extends FirebaseScheduleConstructorWrapper ? never : Functions extends FirebaseRequestConstructorWrapper<unknown, unknown, infer ReturnType> ? ReturnType : never;
}
export type RunnableFirebaseFunctions = (functions.HttpsFunction & functions.Runnable<unknown>) | functions.CloudFunction<unknown> | functions.HttpsFunction | {
    [key: string]: RunnableFirebaseFunctions;
};
export declare class FirebaseFunctionBuilder {
    function<Parameters, FlattenParameters, ReturnType>(Constructor: FirebaseFunctionConstructor<Parameters, FlattenParameters, ReturnType>): FirebaseFunctionConstructorWrapper<Parameters, FlattenParameters, ReturnType>;
    schedule(Constructor: FirebaseScheduleConstructor, schedule: string, timezone: string): FirebaseScheduleConstructorWrapper;
    request<Parameters, FlattenParameters, ReturnType>(Constructor: FirebaseRequestConstructor<Parameters, FlattenParameters, ReturnType>): FirebaseRequestConstructorWrapper<Parameters, FlattenParameters, ReturnType>;
}
export declare function createFirebaseFunctions<Functions extends FirebaseFunctions>(create: (builder: FirebaseFunctionBuilder) => Functions): Functions;
export declare function provideFirebaseFunctions(firebaseFunctions: FirebaseFunctions, macKey: Uint8Array, regions?: string[]): RunnableFirebaseFunctions;
