"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FirestoreDocument = void 0;
const FirestoreCollection_1 = require("./FirestoreCollection");
class FirestoreDocument {
    firestore;
    path;
    constructor(firestore, path) {
        this.firestore = firestore;
        this.path = path;
    }
    getSubCollection(key) {
        return new FirestoreCollection_1.FirestoreCollection(this.firestore, this.path.appending(key));
    }
    async setValues(values) {
        await this.firestore.doc(this.path.fullPath).update(values);
    }
    async getValues() {
        const documentSnapshot = await this.firestore.doc(this.path.fullPath).get();
        if (!documentSnapshot.exists)
            throw new Error('Document does not exist');
        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
        return documentSnapshot.data();
    }
}
exports.FirestoreDocument = FirestoreDocument;
