"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParameterContainer = void 0;
const utils_1 = require("../utils");
class ParameterContainer {
    data;
    logger;
    constructor(data, logger) {
        this.data = data;
        this.logger = logger;
        this.logger.log('ParameterContainer.constructor', { data: data });
    }
    parameter(key, builder) {
        this.logger.log('ParameterContainer.parameter', { key: key, expectedTypes: builder.expectedTypes });
        // Throw error if key couldn't be found
        if (!(key in this.data) && !builder.expectedTypes.has('undefined'))
            throw new utils_1.HttpsError('invalid-argument', `No ${key} in parameters.`, this.logger);
        const parameter = this.data[key];
        // Throw error if type isn't expected
        if (!builder.expectedTypes.has(typeof parameter))
            throw new utils_1.HttpsError('invalid-argument', `Parameter ${key} has an invalid type: ${typeof parameter}`, this.logger);
        return builder.build(parameter, this.logger.nextIndent);
    }
}
exports.ParameterContainer = ParameterContainer;
