"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GuardParameterBuilder = void 0;
const utils_1 = require("../../utils");
class GuardParameterBuilder {
    typeName;
    typeGuard;
    constructor(typeName, typeGuard) {
        this.typeName = typeName;
        this.typeGuard = typeGuard;
    }
    get expectedTypes() {
        return new Set([this.typeName]);
    }
    build(value, logger) {
        logger.log('GuardParameterBuilder.build', { typeName: this.typeName, value: value });
        if (!this.typeGuard(value, logger.nextIndent))
            throw new utils_1.HttpsError('invalid-argument', 'Invalid parameter, type guard failed.', logger);
        return value;
    }
}
exports.GuardParameterBuilder = GuardParameterBuilder;
