"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NullableParameterBuilder = void 0;
const utils_1 = require("../../utils");
class NullableParameterBuilder {
    builder;
    constructor(builder) {
        this.builder = builder;
    }
    get expectedTypes() {
        const expectedTypes = new Set(this.builder.expectedTypes);
        expectedTypes.add('object');
        return expectedTypes;
    }
    build(value, logger) {
        logger.log('NullableParameterBuilder.build', { expectedTypes: this.builder.expectedTypes, value: value });
        if (value === null)
            return null;
        if (typeof value === 'object' && !this.builder.expectedTypes.has('object'))
            throw new utils_1.HttpsError('invalid-argument', 'Value is unexpected an object.', logger);
        return this.builder.build(value, logger.nextIndent);
    }
}
exports.NullableParameterBuilder = NullableParameterBuilder;
