"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const src_1 = require("../../src");
const testSrc_1 = require("../../testSrc");
describe('Base64BytesCoder', () => {
    const bytesCoder = new src_1.Base64BytesCoder();
    it('encode', () => {
        (0, testSrc_1.expect)(bytesCoder.encode('StMqe7yA2IbxPzF1XyrNlw==')).to.be.deep.equal(new Uint8Array([74, 211, 42, 123, 188, 128, 216, 134, 241, 63, 49, 117, 95, 42, 205, 151]));
        (0, testSrc_1.expect)(bytesCoder.encode('Msum6z5abPiyJP5Q1+FMo1O+nnhYAOrFm8s===')).to.be.deep.equal(new Uint8Array([50, 203, 166, 235, 62, 90, 108, 248, 178, 36, 254, 80, 215, 225, 76, 163, 83, 190, 158, 120, 88, 0, 234, 197, 155, 203]));
    });
    it('decode', () => {
        (0, testSrc_1.expect)(bytesCoder.decode(new Uint8Array([74, 211, 42, 123, 188, 128, 216, 134, 241, 63, 49, 117, 95, 42, 205, 151]))).to.be.deep.equal('StMqe7yA2IbxPzF1XyrNlw==');
        (0, testSrc_1.expect)(bytesCoder.decode(new Uint8Array([50, 203, 166, 235, 62, 90, 108, 248, 178, 36, 254, 80, 215, 225, 76, 163, 83, 190, 158, 120, 88, 0, 234, 197, 155, 203]))).to.be.deep.equal('Msum6z5abPiyJP5Q1+FMo1O+nnhYAOrFm8s=');
    });
});
