import { AuthData } from "firebase-functions/lib/common/providers/tasks";
import { FirebaseFunction, ILogger, IParameterContainer } from "firebase-function";
export type Parameters = {
    v1: string;
    v2: number;
    v3: "a" | "b";
};
export declare class TestReturnType implements FirebaseFunction.Flattable<{
    v1: string;
    v2: number;
}> {
    readonly v1_raw: string;
    readonly v2_raw: number;
    constructor(v1_raw: string, v2_raw: number);
    get flatten(): {
        v1: string;
        v2: number;
    };
}
export declare class TestFirebaseFunction implements FirebaseFunction<Parameters, Parameters, TestReturnType> {
    parameters: Parameters;
    constructor(parameterContainer: IParameterContainer, auth: AuthData | null, logger: ILogger);
    execute(): Promise<TestReturnType>;
}
