"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TestFirebaseFunction = exports.TestReturnType = void 0;
const firebase_function_1 = require("firebase-function");
class TestReturnType {
    v1_raw;
    v2_raw;
    constructor(v1_raw, v2_raw) {
        this.v1_raw = v1_raw;
        this.v2_raw = v2_raw;
    }
    get flatten() {
        return {
            v1: this.v1_raw + " flattened",
            v2: this.v2_raw + 10,
        };
    }
}
exports.TestReturnType = TestReturnType;
class TestFirebaseFunction {
    parameters;
    constructor(parameterContainer, auth, logger) {
        logger.log("TestFirebaseFunction.constructor", null, "notice");
        const parameterParser = new firebase_function_1.ParameterParser({
            v1: new firebase_function_1.ValueParameterBuilder("string"),
            v2: new firebase_function_1.ValueParameterBuilder("number"),
            v3: new firebase_function_1.GuardParameterBuilder("string", (value) => value === "a" || value === "b"),
        }, logger.nextIndent);
        this.parameters = parameterParser.parse(parameterContainer);
    }
    async execute() {
        return new TestReturnType(this.parameters.v3 + " " + this.parameters.v1, this.parameters.v2);
    }
}
exports.TestFirebaseFunction = TestFirebaseFunction;
