"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const src_1 = require("../../src");
const testSrc_1 = require("../../testSrc");
describe('Logger', () => {
    it('log not verbose', () => {
        const logger = src_1.Logger.start('name 0');
        logger.log('name 1');
        logger.nextIndent.log('name 2', { k1: 1 }, 'notice');
        (0, testSrc_1.expect)(logger.completeLog).to.be.equal('> [debug: name 0]\n> [debug: name 1]\n|   > [notice: name 2]\n');
    });
    it('log verbose', () => {
        const logger = src_1.Logger.start('name 0', { k2: 'd' }, 'info', true);
        logger.log('name 1');
        logger.nextIndent.log('name 2', { k1: 1 }, 'notice');
        (0, testSrc_1.expect)(logger.completeLog).to.be.equal('> [info: name 0]: {\n|     k2: \'d\'\n| }\n> [debug: name 1]: {}\n|   > [notice: name 2]: {\n|   |     k1: 1\n|   | }\n');
    });
});
