import { type FirebaseFunctions } from '../src';
import type { FirebaseApp } from './FirebaseApp';
export declare class FirebaseFunctionsCaller<Functions extends FirebaseFunctions> {
    private readonly functions;
    private readonly options;
    private readonly name;
    constructor(functions: Functions, options: FirebaseApp.Options, name?: string);
    function<Key extends FirebaseFunctions.IsRecord<FirebaseFunctions> extends true ? keyof FirebaseFunctions : never>(key: Key): FirebaseFunctionsCaller<Functions[Key]>;
    private createMacTag;
    private get functionsInstance();
    callFunction(parameters: FirebaseFunctions.FunctionFlattenParameters<Functions>): Promise<FirebaseFunctions.FunctionReturnType<Functions>>;
    callRequest(parameters: FirebaseFunctions.RequestFlattenParameters<Functions>): Promise<FirebaseFunctions.RequestReturnType<Functions>>;
}
